import { Request, Response } from "express"
import * as TEMPLATE_NAME_service from "../Services/TEMPLATE_NAME.service"

export async function post({ body }: Request, res: Response) {
  try {
    await TEMPLATE_NAME_service.insertOne(body)

    res.json({ message: `insert into TEMPLATE_NAME` })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem to insert into TEMPLATE_NAME` })
  }
}
export async function get(_req: Request, res: Response) {
  try {
    const response = await TEMPLATE_NAME_service.getAll()

    res.json({ message: `get all from TEMPLATE_NAME`, data: response })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem get all from TEMPLATE_NAME` })
  }
}

export async function getOne(req: Request, res: Response) {
  try {
    const { id } = req.params

    const response = await TEMPLATE_NAME_service.getOne(id)

    res.json({ message: `get ${id} from TEMPLATE_NAME`, data: response })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem to get from TEMPLATE_NAME` })
  }
}

export async function updateOne(req: Request, res: Response) {
  try {
    const { id } = req.params

    await TEMPLATE_NAME_service.updateOne(id)

    res.json({ message: `update ${id} from TEMPLATE_NAME` })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem to update from TEMPLATE_NAME` })
  }
}

export async function removeOne(req: Request, res: Response) {
  try {
    const { id } = req.params

    await TEMPLATE_NAME_service.removeOne(id)

    res.json({ message: `delete ${id} from TEMPLATE_NAME` })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem to delete from TEMPLATE_NAME` })
  }
}

//-------PAGES SETTINGS--------------

export async function pages(_req: Request, res: Response) {
  try {
    res.json({ message: `Filter PAGES from TEMPLATE_NAME` })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem to Filter PAGES from TEMPLATE_NAME` })
  }
}
