import { Request, Response } from "express"

export async function post(_req: Request, res: Response) {
  try {
    res.json({ message: `insert into TEMPLATE_NAME` })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem to insert into TEMPLATE_NAME` })
  }
}
export async function get(_req: Request, res: Response) {
  try {
    res.json({ message: `get all from TEMPLATE_NAME`, data: [] })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem get all from TEMPLATE_NAME` })
  }
}

export async function getOne(req: Request, res: Response) {
  try {
    const { id } = req.params

    res.json({ message: `get ${id} from TEMPLATE_NAME`, data: {} })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem to get from TEMPLATE_NAME` })
  }
}

export async function updateOne(req: Request, res: Response) {
  try {
    const { id } = req.params

    res.json({ message: `update ${id} from TEMPLATE_NAME` })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem to update from TEMPLATE_NAME` })
  }
}

export async function removeOne(req: Request, res: Response) {
  try {
    const { id } = req.params

    res.json({ message: `delete ${id} from TEMPLATE_NAME` })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem to delete from TEMPLATE_NAME` })
  }
}

//-------PAGES SETTINGS--------------

export async function pages(_req: Request, res: Response) {
  try {
    res.json({ message: `Filter PAGES from TEMPLATE_NAME` })
  } catch (error: any) {
    res.status(error.status ?? 400).json({ message: error.message ?? `problem to Filter PAGES from TEMPLATE_NAME` })
  }
}
