import * as express_serve_static_core from 'express-serve-static-core';
import { RequestHandler } from 'express';

type MiddlewareOptions = RequestHandler[] | RequestHandler | MethodsGuide;

interface RouterGuide extends MethodsGuide {
    path: string;
    middleware?: MiddlewareOptions;
    children?: RouterGuide[];
}
interface MethodsGuide {
    get?: RequestHandler[] | RequestHandler;
    post?: RequestHandler[] | RequestHandler;
    put?: RequestHandler[] | RequestHandler;
    delete?: RequestHandler[] | RequestHandler;
}

declare function registerRoutes(basePath: string, routes: RouterGuide[] | RouterGuide): express_serve_static_core.Router;

declare function createCrud(table: string, service?: boolean): {
    routed: (options?: {
        middleware?: RequestHandler[] | RequestHandler | MethodsGuide;
        pages?: boolean;
        basePath?: string;
        methods: {
            get?: boolean;
            post?: boolean;
            getOne?: boolean;
            put?: boolean;
            delete?: boolean;
        };
        children?: RouterGuide | RouterGuide[];
    }) => express_serve_static_core.Router;
};

interface createAPIOptions {
    path: string;
    middleware?: MiddlewareOptions;
    pages?: boolean;
    service?: boolean;
    get?: boolean;
    post?: boolean;
    getOne?: boolean;
    put?: boolean;
    delete?: boolean;
    children?: RouterGuide | RouterGuide[];
}
declare function createAPI(basePath: string, params: createAPIOptions | createAPIOptions[]): express_serve_static_core.Router | express_serve_static_core.Router[];

export { createAPI, type createAPIOptions, createCrud, registerRoutes };
