"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  createAPI: () => createAPI,
  createCrud: () => createCrud,
  registerRoutes: () => registerRoutes
});
module.exports = __toCommonJS(src_exports);

// src/Controllers/registerRoutes.ts
var import_express = require("express");
var router = (0, import_express.Router)();
function registerRoutes(basePath, routes) {
  if (Array.isArray(routes)) {
    for (const route of routes) {
      if (route.path.toLowerCase() === "index") {
        route.path = "";
        route.children = [];
      }
      const PATH = !basePath ? parsePath(`/${route.path}`) : parsePath(`/${basePath}/${route.path}`);
      const entries = Object.entries(route);
      let middleware = null;
      for (let [keys, functions] of entries) {
        switch (keys) {
          case "middleware":
            if (functions)
              middleware = functions;
            break;
          case "get":
          case "post":
          case "put":
          case "delete":
            if (Array.isArray(functions)) {
              functions = middlewareParse(keys, middleware, functions);
              router[keys](PATH, ...functions);
            } else {
              functions = middlewareParse(keys, middleware, functions);
              router[keys](PATH, functions);
            }
            break;
          case "children":
            registerRoutes(PATH, functions);
            break;
        }
      }
    }
  } else {
    if (routes.path.toLowerCase() === "index") {
      routes.path = "";
      routes.children = [];
    }
    const PATH = !basePath ? parsePath(`/${routes.path}`) : parsePath(`/${basePath}/${routes.path}`);
    const entries = Object.entries(routes);
    let middleware = null;
    for (let [keys, functions] of entries) {
      switch (keys) {
        case "middleware":
          if (functions)
            middleware = functions;
          break;
        case "get":
        case "post":
        case "put":
        case "delete":
          if (Array.isArray(functions)) {
            functions = middlewareParse(keys, middleware, functions);
            router[keys](PATH, ...functions);
          } else {
            functions = middlewareParse(keys, middleware, functions);
            router[keys](PATH, functions);
          }
          break;
        case "children":
          registerRoutes(PATH, functions);
          break;
      }
    }
  }
  return router;
}
function parsePath(path3) {
  return path3.replace(new RegExp("//", "g"), "/");
}
function middlewareParse(keys, middleware, func) {
  if (Array.isArray(func)) {
    if (middleware) {
      if (Array.isArray(middleware)) {
        return [...middleware, ...func];
      } else if (typeof middleware === "object") {
        if (middleware[keys]) {
          if (Array.isArray(middleware[keys])) {
            return [...[middleware[keys]], ...func];
          } else {
            return [middleware[keys], ...func];
          }
        }
      } else {
        return [middleware, ...func];
      }
    }
  } else {
    if (middleware) {
      if (Array.isArray(middleware)) {
        return [...middleware, func];
      } else if (typeof middleware === "object") {
        if (middleware[keys]) {
          if (Array.isArray(middleware[keys])) {
            return [...[middleware[keys]], func];
          } else {
            return [middleware[keys], func];
          }
        }
      } else {
        return [middleware, func];
      }
    }
  }
  return func;
}

// src/Controllers/createCrud.ts
var import_path2 = __toESM(require("path"));

// src/Utils/functions.ts
var fs = __toESM(require("fs"));
var import_path = __toESM(require("path"));
function findFolder(directory, nameFolder) {
  let pathFound = null;
  function searchInDirectory(directorio) {
    const elements = fs.readdirSync(directorio);
    for (const element of elements) {
      const fullPath = import_path.default.join(directorio, element);
      const stats = fs.statSync(fullPath);
      if (stats.isDirectory()) {
        if (element === nameFolder) {
          pathFound = fullPath;
          break;
        } else {
          searchInDirectory(fullPath);
        }
      }
    }
  }
  searchInDirectory(directory);
  return pathFound;
}
function createIfNotExists(rutaCarpeta) {
  if (!fs.existsSync(rutaCarpeta))
    fs.mkdirSync(rutaCarpeta, { recursive: true });
}
function capitalizeFirstLetter(texto) {
  return texto.charAt(0).toUpperCase() + texto.substring(1);
}

// src/Controllers/createCrud.ts
var fs2 = __toESM(require("fs"));
function createCrud(table, service = true) {
  table = table.replace(/[^\w\s]/gi, "_");
  const className = capitalizeFirstLetter(table);
  const actualPath = import_path2.default.resolve();
  const folder = findFolder(actualPath, "API");
  if (!folder)
    throw "'API' folder not found";
  if (service)
    createService(folder, className);
  const instance = createController(folder, className, service);
  function routed(options) {
    const routing = {
      middleware: options?.middleware,
      path: table,
      children: []
    };
    const children = {
      middleware: options?.middleware,
      path: ":id"
    };
    const pages = {
      path: "pages/:page",
      get: instance["pages"] ?? []
    };
    if (options) {
      const methods = options.methods;
      const isTrue = Object.values(methods).some((val) => val === true);
      const isFalse = Object.values(methods).some((val) => val === false);
      if (isTrue) {
        console.log("solo falso");
        routing.get = methods.get ? instance["get"] ?? [] : [];
        routing.post = methods.post ? instance["post"] ?? [] : [];
        children.get = methods.getOne ? instance["getOne"] ?? [] : [];
        children.put = methods.put ? instance["updateOne"] ?? [] : [];
        children.delete = methods.delete ? instance["removeOne"] ?? [] : [];
      } else if (isFalse) {
        routing.get = methods.get === false ? [] : instance["get"] ?? [];
        routing.post = methods.post === false ? [] : instance["post"] ?? [];
        children.get = methods.getOne === false ? [] : instance["getOne"] ?? [];
        children.put = methods.put === false ? [] : instance["updateOne"] ?? [];
        children.delete = methods.delete === false ? [] : instance["removeOne"] ?? [];
      } else {
        routing.get = instance["get"] ?? [];
        routing.post = instance["post"] ?? [];
        children.get = instance["getOne"] ?? [];
        children.put = instance["updateOne"] ?? [];
        children.delete = instance["removeOne"] ?? [];
      }
    }
    routing.children?.push(children);
    if (options?.pages)
      routing.children?.push(pages);
    if (options?.children) {
      if (Array.isArray(options.children))
        routing.children?.concat(options.children);
      else
        routing.children?.push(options.children);
    }
    return registerRoutes(options?.basePath ?? "", routing);
  }
  return { routed };
}
var createController = (folder, className, service) => {
  let template;
  if (!fs2.existsSync(`${folder}/Controllers/${className}.controller.ts`)) {
    createIfNotExists(`${folder}/Controllers`);
    console.log("className", className);
    const baseTemplate = `${__dirname}/../Template/Controllers`;
    if (className.toLowerCase() === "index") {
      template = `TEMPLATE_NAMEws_index.controller.ts`;
      if (service)
        template = `TEMPLATE_NAME_index.controller.ts`;
    } else {
      template = `TEMPLATE_NAME.controller.ts`;
      if (!service)
        template = `TEMPLATE_NAMEws.controller.ts`;
    }
    const ControllerOriginal = fs2.readFileSync(baseTemplate + "/" + template, "utf-8");
    const ControllerModif = ControllerOriginal.replace(new RegExp("TEMPLATE_NAME", "g"), className);
    fs2.writeFileSync(`${folder}/Controllers/${className}.controller.ts`, ControllerModif, "utf-8");
    console.log(`create ${className}`);
  }
  const instance = require(`${folder}/Controllers/${className}.controller.ts`);
  return instance;
};
var createService = (folder, serviceName) => {
  if (!fs2.existsSync(`${folder}/Services/${serviceName}.service.ts`)) {
    createIfNotExists(`${folder}/Services`);
    const ControllerOriginal = fs2.readFileSync(`${__dirname}/../Template/Services/TEMPLATE_NAME.service.ts`, "utf-8");
    const ControllerModif = ControllerOriginal.replace(new RegExp("TEMPLATE_NAME", "g"), serviceName);
    fs2.writeFileSync(`${folder}/Services/${serviceName}.service.ts`, ControllerModif, "utf-8");
    console.log(`create service: ${serviceName}`);
  }
};

// src/Controllers/createAPI.ts
function createAPI(basePath, params) {
  let route;
  if (Array.isArray(params)) {
    route = [];
    for (const param of params) {
      let table = "index";
      let options = { methods: {} };
      options.middleware ??= param.middleware;
      options.pages ??= param.pages;
      options.basePath ??= basePath;
      options.methods.get ??= param.get;
      options.methods.getOne ??= param.getOne;
      options.methods.post ??= param.post;
      options.methods.put ??= param.put;
      options.methods.delete ??= param.delete;
      options.children ??= param.children;
      table = param.path ? param.path : table;
      route.push(createCrud(table, param.service).routed(options));
    }
  } else {
    let table = "index";
    let options = { methods: {} };
    options.middleware ??= params.middleware;
    options.pages ??= params.pages;
    options.basePath ??= basePath;
    options.methods.get ??= params.get;
    options.methods.getOne ??= params.getOne;
    options.methods.post ??= params.post;
    options.methods.put ??= params.put;
    options.methods.delete ??= params.delete;
    options.children ??= params.children;
    table = params.path && params.path !== "" ? params.path : table;
    route = createCrud(table, params.service).routed(options);
  }
  return route;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createAPI,
  createCrud,
  registerRoutes
});
//! NECESITAMOS VALIDR SI EXISTE EN DIST O EXISTE EN TEST
